#!/bin/sh

#--------------------------------------------------------------------
# cginmap.cgi	cginmap
#
# Creation:     07.02.2003  Kai Hauser
# Last Update:  07.02.2003  Kai Hauser
#--------------------------------------------------------------------
     
SEC_REALM='misc'
SEC_ACTION='nmap'
../ sec-lib.cgi


# Variabeln parsen
eval "`proccgi $*`"

nmap_cmd=""

# Scan Options

if [ -n "$FORM_scan_type" ]
then
    nmap_cmd="$FORM_scan_type"
fi

if [ -n "$FORM_sI" ]
then
    nmap_cmd="$nmap_cmd -sI $FORM_sI"
fi

if [ -n "$FORM_b" ]
then
    nmap_cmd="$nmap_cmd -b $FORM_b"
fi

# General Options

if [ -n "$FORM_iR" ]
then
    nmap_cmd="$nmap_cmd -iR"
fi

if [ -n "$FORM_P0" ]
then
    nmap_cmd="$nmap_cmd -P0"
fi

if [ -n "$FORM_PT" ]
then
    nmap_cmd="$nmap_cmd -PT"
fi

if [ -n "$FORM_PS" ]
then
    nmap_cmd="$nmap_cmd -PS"
fi

if [ -n "$FORM_PI" ]
then
    nmap_cmd="$nmap_cmd -PI"
fi

if [ -n "$FORM_PP" ]
then
    nmap_cmd="$nmap_cmd -PP"
fi

if [ -n "$FORM_PM" ]
then
    nmap_cmd="$nmap_cmd -PM"
fi

if [ -n "$FORM_PB" ]
then
    nmap_cmd="$nmap_cmd -PB"
fi

if [ -n "$FORM_O" ]
then
    nmap_cmd="$nmap_cmd -O"
fi

if [ -n "$FORM_I" ]
then
    nmap_cmd="$nmap_cmd -I"
fi

if [ -n "$FORM_f" ]
then
    nmap_cmd="$nmap_cmd -f"
fi

if [ -n "$FORM_v" ]
then
    nmap_cmd="$nmap_cmd -v"
fi

if [ -n "$FORM_F" ]
then
    nmap_cmd="$nmap_cmd -F"
fi

if [ -n "$FORM_n" ]
then
    nmap_cmd="$nmap_cmd -n"
fi

if [ -n "$FORM_R" ]
then
    nmap_cmd="$nmap_cmd -R"
fi

if [ -n "$FORM_r" ]
then
    nmap_cmd="$nmap_cmd -r"
fi

if [ -n "$FORM_randomize_hosts" ]
then
    nmap_cmd="$nmap_cmd --randomize_hosts"
fi

#textfelder
if [ -n "$FORM_p" ]
then
    nmap_cmd="$nmap_cmd -p $FORM_p"
fi

if [ -n "$FORM_D" ]
then
    nmap_cmd="$nmap_cmd -D $FORM_D"
fi

if [ -n "$FORM_S" ]
then
    nmap_cmd="$nmap_cmd -S $FORM_S"
fi

if [ -n "$FORM_g" ]
then
    nmap_cmd="$nmap_cmd -g $FORM_g"
fi

if [ -n "$FORM_data_length" ]
then
    nmap_cmd="$nmap_cmd --data_length $FORM_data_length"
fi

if [ -n "$FORM_M" ]
then
    nmap_cmd="$nmap_cmd -M $FORM_M"
fi

if [ -n "$FORM_e" ]
then
    nmap_cmd="$nmap_cmd -e $FORM_e"
fi

# Timing Options

if [ -n "$FORM_T" ]
then
    nmap_cmd="$nmap_cmd $FORM_T"
fi

if [ -n "$FORM_host_timeout" ]
then
    nmap_cmd="$nmap_cmd --host_timeout $FORM_host_timeout"
fi

if [ -n "$FORM_max_rtt_timeout" ]
then
    nmap_cmd="$nmap_cmd --max_rtt_timeout $FORM_max_rtt_timeout"
fi

if [ -n "$FORM_min_rtt_timeout" ]
then
    nmap_cmd="$nmap_cmd --min_rtt_timeout $FORM_min_rtt_timeout"
fi

if [ -n "$FORM_initial_rtt_timeout" ]
then
    nmap_cmd="$nmap_cmd --initial_rtt_timeout $FORM_initial_rtt_timeout"
fi

if [ -n "$FORM_max_parallelism" ]
then
    nmap_cmd="$nmap_cmd --max_parallelism $FORM_max_parallelism"
fi

if [ -n "$FORM_scan_delay" ]
then
    nmap_cmd="$nmap_cmd --scan_delay $FORM_scan_delay"
fi

# File Options

if [ -n "$FORM_log_type" ]
then
    if [ -n "$FORM_logfile" ]
    then
        nmap_cmd="$nmap_cmd $FORM_log_type"
        nmap_cmd="$nmap_cmd $FORM_logfile"
    else
        nmap_cmd="$nmap_cmd $FORM_log_type"
        nmap_cmd="$nmap_cmd scanresults.log"     
    fi
fi

if [ -n "$FORM_iL" ]
then
    nmap_cmd="$nmap_cmd -iL $Form_iL"
fi

if [ -n "$FORM_append_output" ]
then
    nmap_cmd="$nmap_cmd --append_output"
fi

# Target Setup

if [ -n "$FORM_host" ]
then
    nmap_cmd="$nmap_cmd $FORM_host"
#else
#    nmap_cmd="$nmap_cmd $REMOTE_ADDR"
fi

# HTML-Seite ausgeben und nmap aufrufen

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo ""
echo '<html><head>'
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo '<title>nmap</title>'
echo '</head><body bgcolor="#FFFFFF" text="#000000">'
echo "<pre>"      
echo "nmap $nmap_cmd"
echo "--"

if [ ! -f "/usr/local/bin/nmap" ]
then
    echo "opt_nmap nicht installiert?"
else
    /usr/local/bin/nmap $nmap_cmd
fi

echo "</pre>"
echo "</body></html>"